//+------------------------------------------------------------------+
//|                                                               XO |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0
#property indicator_levelcolor Gray

//
//
//
//
//

extern double BoxSize          = 25;
extern int    PriceCount       = 4;
extern int    PriceShift       = 0;
extern int    Level            = 1;
extern bool   LevelsVisible    = true;
extern color  TextColor        = Silver;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "XOarrows";
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Orange;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double Hi[];
double Lo[];
double ne[];
double no[];
double kr[];
double trend[];

//
//
//
//
//

string shortName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);   
      SetIndexBuffer(0,kr); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,no); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ne); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,Hi);
      SetIndexBuffer(4,Lo);
      SetIndexBuffer(5,trend);

      if (LevelsVisible)
      {
         SetLevelValue(1, Level);
         SetLevelValue(2,-Level);
      }
      else
      {
         SetLevelValue(1,EMPTY_VALUE);
         SetLevelValue(2,EMPTY_VALUE);
      }            

      //
      //
      //
      //
      //
      
   shortName = arrowsIdentifier+" XO ("+DoubleToStr(BoxSize,2)+")";
   IndicatorShortName(shortName);
   return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   ObjectDelete(arrowsIdentifier+":boxSize");
   ObjectDelete(arrowsIdentifier+":currentValue");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _kr 0
#define _no 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
    
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      double pipModifier = 1; if (Digits==3 || Digits==5) pipModifier=10;
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {         
         if (i>=(Bars-PriceCount-1)) { Hi[i]=Close[i+PriceShift]*PriceCount; Lo[i]=Close[i+PriceShift]*PriceCount; work[r][_no] = 0; work[r][_kr] = 0; continue; }

         //
         //
         //
         //
         //
      
         double cur = Close[i+PriceShift];
            for(int k=1; k<PriceCount; k++) cur += Close[i+k+PriceShift];
         Hi[i]        = Hi[i+1];
         Lo[i]        = Lo[i+1];
         kr[i]        = EMPTY_VALUE;
         no[i]        = EMPTY_VALUE;
         ne[i]        = EMPTY_VALUE;
         work[r][_no] = work[r-1][_no];
         work[r][_kr] = work[r-1][_kr];
         trend[i]     = 0;
            if (cur > (Hi[i]+BoxSize*pipModifier*Point)) { Hi[i] = cur; Lo[i] = cur-BoxSize*pipModifier*Point; work[r][_kr] += 1; work[r][_no] = 0; }
            if (cur < (Lo[i]-BoxSize*pipModifier*Point)) { Lo[i] = cur; Hi[i] = cur+BoxSize*pipModifier*Point; work[r][_no] -= 1; work[r][_kr] = 0; }
               if (work[r][_kr] >  Level) trend[i]= 1;
               if (work[r][_no] < -Level) trend[i]=-1;
               if (trend[i]== 1) kr[i] = work[r][_kr];
               if (trend[i]==-1) no[i] = work[r][_no];
               if (trend[i]== 0)
               {
                  if (work[r][_kr]>0) 
                        ne[i] = work[r][_kr]; 
                  else  ne[i] = work[r][_no]; 
               }
            manageArrow(i);
      }
      manageAlerts();
      manageDisplay();
      return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageDisplay()
{
      int window = WindowFind(shortName);
      if (window==-1) return;
      string name = arrowsIdentifier+":boxSize";
         ObjectDelete(name);
         ObjectCreate(name,OBJ_LABEL,window,0,0);
            ObjectSet(name,OBJPROP_CORNER,1);
            ObjectSet(name,OBJPROP_XDISTANCE,10);
            ObjectSet(name,OBJPROP_YDISTANCE,10);
            ObjectSetText(name,"box size : "+DoubleToStr(BoxSize,1),8,"Arial",TextColor);
      name = arrowsIdentifier+":currentValue";
      double value = 0;
         if (kr[0]!=EMPTY_VALUE) value=kr[0];
         if (no[0]!=EMPTY_VALUE) value=no[0];
         if (ne[0]!=EMPTY_VALUE) value=ne[0];
         ObjectDelete(name);
         ObjectCreate(name,OBJ_LABEL,window,0,0);
            ObjectSet(name,OBJPROP_CORNER,1);
            ObjectSet(name,OBJPROP_XDISTANCE,10);
            ObjectSet(name,OBJPROP_YDISTANCE,22);
            ObjectSetText(name,"current value : "+DoubleToStr(value,1),8,"Arial",TextColor);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," XO trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"XO "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,139,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,139,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}